import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.JSONResponse;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.TestApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseRelatedApiService;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.redis.data.util.RedisUtil;
import com.gic.wechat.api.dto.qywx.DepartmentDTO;
import com.gic.wechat.api.dto.qywx.QywxImageExternalMessageDTO;
import com.gic.wechat.api.dto.qywx.QywxXcxSendMessageDTO;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.enums.QywxMediaTypeEnum;
import com.gic.wechat.api.service.qywx.QywxDepartmentApiService;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.binarywang.java.emoji.EmojiConverter;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath:applicationContext-conf.xml"})
public class ServiceTest {
    @Autowired
    private WxEnterpriseRelatedApiService wxEnterpriseRelatedApiService;

    @Autowired
    private QywxUserApiService qywxUserApiService;

    @Autowired
    private QywxDepartmentApiService qywxDepartmentApiService;

    @Autowired
    private QywxSuiteApiService qywxSuiteApiService;

    @Autowired
    private StaffApiService staffApiService;

    @Autowired
    private TestApiService testApiService;

    @Autowired
    private DepartmentApiService departmentApiService;


    private final ExecutorService pools = Executors.newFixedThreadPool(50);

    @Test
	public void test() {
        int i=2000;
        while (i-->0) {
            departmentApiService.listAllDepartment(i+"");
        }

        try {
            Thread.sleep(1000000L);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


//    @Test
//    public void test1() {
//        String res = qywxUserApiService.leaveClerkExternal("ww9ede832a84b7ae5f"
//                , "01YQ-pcdYzF3K0So8uCFfkB5i8D5EBW7KcVB4qA8Ktk", 0, 1000);
//        JSONArray jsonArray = JSONArray.parseArray(res);
//        jsonArray.forEach(o -> {
//            JSONObject mid = (JSONObject) o;
//            qywxUserApiService.leaveClerkReTransfer("ww9ede832a84b7ae5f"
//                    , "01YQ-pcdYzF3K0So8uCFfkB5i8D5EBW7KcVB4qA8Ktk", mid.getString("handover_userid")
//                    , mid.getString("handover_userid"), mid.getString("external_userid"));
//        });
//        System.out.println(res);
//    }
//
//    @Test
//    public void test2() {
//        UserDTO userDTO = new UserDTO();
//        userDTO.setUserid("niweizhong");
//        userDTO.setName("空闻大师");
//        userDTO.setDepartment(new Integer[]{4});
//        userDTO.setMobile("17605628855");
//        userDTO.setCorpid("ww9ede832a84b7ae5f");
//        JSONResponse workWxUser = qywxUserApiService.createWorkWxUser(userDTO, "ww9ede832a84b7ae5f", "ww7d6566614055cf27");
//        System.out.println(JSONObject.toJSONString(workWxUser));
//    }
//
//    @Test
//    public void list() {
//
//        List<DepartmentDTO> list = qywxDepartmentApiService.listSelfDepartment("ww9ede832a84b7ae5f"
//                , "3aOw7jbcHlHkDmOi5TuG42Ta8NqskOhZxy5urrmaGl8", 1);
//        Iterator<DepartmentDTO> iterator = list.iterator();
////		while (iterator.hasNext()) {
////			DepartmentDTO next = iterator.next();
////			if(!next.getParentid().equals("1")) {
////				iterator.remove();
////			}
////		}
//        System.out.println(JSONObject.toJSONString(list));
//    }
//
    @Test
    public void addDepart() {
        DepartmentDTO dto = new DepartmentDTO();
		dto.setName("测试order");
		dto.setOrder(2147484447L);
		dto.setParentid(1);

		JSONResponse department = qywxDepartmentApiService.createSelfDepartment("ww9ede832a84b7ae5f"
				, "3aOw7jbcHlHkDmOi5TuG42Ta8NqskOhZxy5urrmaGl8", dto);
//		List<DepartmentDTO> list = (List<DepartmentDTO>) department;
		System.out.println(JSONObject.toJSONString(department));
    }
//
//    @Test
//    public void getUser() {
//        DepartmentDTO dto = new DepartmentDTO();
////		dto.set
//        UserDTO phonenumber = qywxUserApiService.getWxUserByPhonenumber("ww9ede832a84b7ae5f"
//                , "ww7d6566614055cf27", "13735457631");
////		String phonenumber = phonenumber;
////		UserDTO phonenumber = (UserDTO) useridBymobile;
//        System.out.println(JSONObject.toJSONString(phonenumber));
//    }
//
@Test
public void createSelfUser() {
    UserDTO userDTO = new UserDTO();
    userDTO.setUserid("niweizhong2");
    userDTO.setName("空闻大师2");
    userDTO.setDepartment(new Integer[]{5072});
    userDTO.setMobile("17605628851");
    userDTO.setCorpid("ww9ede832a84b7ae5f");
    JSONResponse workWxUser = qywxUserApiService.createSelfWorkWxUser(userDTO, "n",
            "3aOw7jbcHlHkDmOi5TuG42Ta8NqskOhZxy5urrmaGl8");
    System.out.println(JSONObject.toJSONString(workWxUser));
}


@Test
public void sendMessage() {
    QywxXcxSendMessageDTO messageDTO = new QywxXcxSendMessageDTO();
    messageDTO.setAppid("wx6054e7be35015afc");
    ArrayList<String> userIDs = new ArrayList<>();
    userIDs.add("9ae4c4f1277340a186b16a17d937c72c");
    messageDTO.setUserIds(userIDs);
    messageDTO.setTitle("我的测试test");
    messageDTO.setDescription("我的测试test11111");
    HashMap<String, String> map = new HashMap<>();
    map.put("名称", "hua");
//    messageDTO.setItems(map);
    boolean ret = qywxSuiteApiService.sendMessage("ww9ede832a84b7ae5f",
            "ww2c34dc56739bb105", messageDTO);
    System.out.println(JSONObject.toJSONString(ret));
}


    @Test
    public void listExternalUserid() {
        UserDTO userDTO = new UserDTO();
        userDTO.setUserid("niweizhong2");
        userDTO.setName("空闻大师2");
        userDTO.setDepartment(new Integer[]{5072});
        userDTO.setMobile("17605628851");
        userDTO.setCorpid("ww9ede832a84b7ae5f");
        String s = qywxUserApiService.listExternalUserid("ww9ede832a84b7ae5f",
                "ww2c34dc56739bb105", "qiuwenmin");
        System.out.println(s);
    }

    @Test
    public void getQrcode() {

        UserDTO workWxUser = qywxUserApiService.getSelfWorkWxUser("ww9ede832a84b7ae5f", "3aOw7jbcHlHkDmOi5TuG42Ta8NqskOhZxy5urrmaGl8", "lining");
        ServiceResponse<String> qrcode = staffApiService.getStaffQrcode("167442", "ff8080817181d322017182737b16021f");
        System.out.println(JSONObject.toJSONString(qrcode));
    }


    @Test
    public void extensionList() {

        String s = qywxUserApiService.listSelfExternalUserid("ww9ede832a84b7ae5f", "01YQ-pcdYzF3K0So8uCFfkB5i8D5EBW7KcVB4qA8Ktk", "de2c33f2e8924ff884e0073ca2f2f711");
        System.out.println(JSONObject.toJSONString(s));
    }
    @Test
    public void extensionList1() {
        UserDTO selfWorkWxUser = qywxUserApiService.getSelfWorkWxUser("ww9ede832a84b7ae5f", "65zze159pYb4ofbFsIREZ5X7d7iaZ-bWsVIQk2y5kTU", "de2c33f2e8924ff884e0073ca2f2f711");
//        String s = qywxUserApiService.listSelfExternalUserid("ww9ede832a84b7ae5f", "01YQ-pcdYzF3K0So8uCFfkB5i8D5EBW7KcVB4qA8Ktk", "de2c33f2e8924ff884e0073ca2f2f711");
        System.out.println(JSONObject.toJSONString(selfWorkWxUser));
    }



    @Test
    public void extensionList2() {
        String img="d:/test2.jpg";
        byte[] aByte = getFileByteArray(new File(img));
        JSONResponse response = qywxSuiteApiService.uploadMedia("ww9ede832a84b7ae5f", "ww2c34dc56739bb105", aByte,"测试文件", QywxMediaTypeEnum.IMAGE.getCode());
        System.out.println(JSONObject.toJSONString(response));
    }

    @Test
    public void extensionList3() {
//        msg59NLDQAAKvRi-fguFcKRVOjeoJKRJw
//        String img="https://pic01-10001430.image.myqcloud.com/53205d69-01f1-4706-a258-014d59d8d106";
//        byte[] aByte = getByte(img);
//        JSONResponse response = qywxSuiteApiService.uploadMedia("ww9ede832a84b7ae5f", "ww2c34dc56739bb105", aByte, QywxMediaTypeEnum.IMAGE.getCode());
//        System.out.println(JSONObject.toJSONString(response));
        QywxImageExternalMessageDTO messageDTO=new QywxImageExternalMessageDTO();
        messageDTO.setMediaId("msg59NLDQAANPwzc9aMWNCBky8EElovyg");
        messageDTO.setSenderUserId("9ae4c4f1277340a186b16a17d937c72c");
        List<String> list=new ArrayList<>();
        list.add("wm59NLDQAAL0fHb-QEbx-U9pdtRFA1bg");
        messageDTO.setExternalUserid(list);
        JSONResponse response1 = qywxSuiteApiService.sendExternalMessage("ww9ede832a84b7ae5f", "ww2c34dc56739bb105", messageDTO);
        System.out.println(JSONObject.toJSONString(response1));
    }

    @Test
    public void extensionList4() {
//        msg59NLDQAAKvRi-fguFcKRVOjeoJKRJw
        String img="https://pic01-10001430.image.myqcloud.com/53205d69-01f1-4706-a258-014d59d8d106";
        byte[] aByte = getByte(img);
//        JSONResponse response = qywxSuiteApiService.uploadMedia("ww9ede832a84b7ae5f", "ww2c34dc56739bb105", aByte, QywxMediaTypeEnum.IMAGE.getCode());
//        System.out.println(JSONObject.toJSONString(response));
        JSONResponse response1 = qywxSuiteApiService.uploadImage("ww9ede832a84b7ae5f", "ww2c34dc56739bb105", aByte);
        System.out.println(JSONObject.toJSONString(response1));
    }


    @Test
    public void redis() {
	    long key=111;
        RedisUtil.setCache("test-key-11",key);
        Long key2=111L;
        RedisUtil.setCache("test-key-112",key2);

        RedisUtil.setCache("test-key-113",1);
        int ke22y=22;
        RedisUtil.setCache("test-key-115",ke22y);

        RedisUtil.setCache("test-key-114","1");


    }


    @Test
    public void staff() {
        EmojiConverter emojiConverter = EmojiConverter.getInstance();
//        List<UserDTO> userDTOList = qywxUserApiService.listSelfDepartmentUser("wwd5b0d17fd7952df8", "cFhOS1fkb8-qJNHDr5S8QI1JbpsTLCSTOsxQQUUmYz4", "1", 0);
        UserDTO wxUser = qywxUserApiService.getSelfWorkWxUser("wwd5b0d17fd7952df8", "cFhOS1fkb8-qJNHDr5S8QI1JbpsTLCSTOsxQQUUmYz4", "QingSu");
        String s = EmojiFilterUtil.removeAllEmoji(wxUser.getName());
//        String name = (String) b;
//        ServiceResponse res = staffApiService.getWxSaveNew("a.XiaoPangZhi", "ca66a01b79474c40b3e7c7f93daf1a3b");
        System.out.println(JSONObject.toJSONString(wxUser));


    }

    private byte[] getByte(String strUrl){
        ByteArrayOutputStream baos = null;
        try
        {
            URL u = new URL(strUrl);
            BufferedImage image = ImageIO.read(u);

            //convert BufferedImage to byte array
            baos = new ByteArrayOutputStream();
            ImageIO.write( image, "jpg", baos);
            baos.flush();

            return baos.toByteArray();
        }
        catch (Exception e)
        {
        }
        finally
        {
            if(baos != null)
            {
                try {
                    baos.close();
                } catch (IOException e) {
                }
                return baos.toByteArray();
            }
            return null;
        }
    }

    public static byte[] getFileByteArray(File file) {
        long fileSize = file.length();
        if (fileSize > Integer.MAX_VALUE) {
            System.out.println("file too big...");
            return null;
        }
        byte[] buffer = null;
        try (FileInputStream fi = new FileInputStream(file)) {
            buffer = new byte[(int) fileSize];
            int offset = 0;
            int numRead = 0;
            while (offset < buffer.length
                    && (numRead = fi.read(buffer, offset, buffer.length - offset)) >= 0) {
                offset += numRead;
            }
            // 确保所有数据均被读取
            if (offset != buffer.length) {
                throw new IOException("Could not completely read file "
                        + file.getName());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return buffer;
    }

}
